Fix 'git diff --no-index' with a non-existing symlink target
[git/gitster.git] / contrib / difftool / git-difftool-helper
blob0c48506eebdaab3b04e5c018bcc5233582404432
1 #!/bin/sh
2 # git-difftool-helper is a GIT_EXTERNAL_DIFF-compatible diff tool launcher.
3 # It supports kdiff3, tkdiff, xxdiff, meld, opendiff, emerge, ecmerge,
4 # vimdiff, gvimdiff, and custom user-configurable tools.
5 # This script is typically launched by using the 'git difftool'
6 # convenience command.
8 # Copyright (c) 2009 David Aguilar
10 # Set GIT_DIFFTOOL_NO_PROMPT to bypass the per-file prompt.
11 should_prompt () {
12 ! test -n "$GIT_DIFFTOOL_NO_PROMPT"
15 # Should we keep the backup .orig file?
16 keep_backup_mode="$(git config --bool merge.keepBackup || echo true)"
17 keep_backup () {
18 test "$keep_backup_mode" = "true"
21 # This function manages the backup .orig file.
22 # A backup $MERGED.orig file is created if changes are detected.
23 cleanup_temp_files () {
24 if test -n "$MERGED"; then
25 if keep_backup && test "$MERGED" -nt "$BACKUP"; then
26 test -f "$BACKUP" && mv -- "$BACKUP" "$MERGED.orig"
27 else
28 rm -f -- "$BACKUP"
33 # This is called when users Ctrl-C out of git-difftool-helper
34 sigint_handler () {
35 cleanup_temp_files
36 exit 1
39 # This function prepares temporary files and launches the appropriate
40 # merge tool.
41 launch_merge_tool () {
42 # Merged is the filename as it appears in the work tree
43 # Local is the contents of a/filename
44 # Remote is the contents of b/filename
45 # Custom merge tool commands might use $BASE so we provide it
46 MERGED="$1"
47 LOCAL="$2"
48 REMOTE="$3"
49 BASE="$1"
50 ext="$$$(expr "$MERGED" : '.*\(\.[^/]*\)$')"
51 BACKUP="$MERGED.BACKUP.$ext"
53 # Create and ensure that we clean up $BACKUP
54 test -f "$MERGED" && cp -- "$MERGED" "$BACKUP"
55 trap sigint_handler INT
57 # $LOCAL and $REMOTE are temporary files so prompt
58 # the user with the real $MERGED name before launching $merge_tool.
59 if should_prompt; then
60 printf "\nViewing: '$MERGED'\n"
61 printf "Hit return to launch '%s': " "$merge_tool"
62 read ans
65 # Run the appropriate merge tool command
66 case "$merge_tool" in
67 kdiff3)
68 basename=$(basename "$MERGED")
69 "$merge_tool_path" --auto \
70 --L1 "$basename (A)" \
71 --L2 "$basename (B)" \
72 -o "$MERGED" "$LOCAL" "$REMOTE" \
73 > /dev/null 2>&1
76 tkdiff)
77 "$merge_tool_path" -o "$MERGED" "$LOCAL" "$REMOTE"
80 meld)
81 "$merge_tool_path" "$LOCAL" "$REMOTE"
84 vimdiff)
85 "$merge_tool_path" -c "wincmd l" "$LOCAL" "$REMOTE"
88 gvimdiff)
89 "$merge_tool_path" -c "wincmd l" -f "$LOCAL" "$REMOTE"
92 xxdiff)
93 "$merge_tool_path" \
94 -X \
95 -R 'Accel.SaveAsMerged: "Ctrl-S"' \
96 -R 'Accel.Search: "Ctrl+F"' \
97 -R 'Accel.SearchForward: "Ctrl-G"' \
98 --merged-file "$MERGED" \
99 "$LOCAL" "$REMOTE"
102 opendiff)
103 "$merge_tool_path" "$LOCAL" "$REMOTE" \
104 -merge "$MERGED" | cat
107 ecmerge)
108 "$merge_tool_path" "$LOCAL" "$REMOTE" \
109 --default --mode=merge2 --to="$MERGED"
112 emerge)
113 "$merge_tool_path" -f emerge-files-command \
114 "$LOCAL" "$REMOTE" "$(basename "$MERGED")"
118 if test -n "$merge_tool_cmd"; then
119 ( eval $merge_tool_cmd )
122 esac
124 cleanup_temp_files
127 # Verifies that mergetool.<tool>.cmd exists
128 valid_custom_tool() {
129 merge_tool_cmd="$(git config mergetool.$1.cmd)"
130 test -n "$merge_tool_cmd"
133 # Verifies that the chosen merge tool is properly setup.
134 # Built-in merge tools are always valid.
135 valid_tool() {
136 case "$1" in
137 kdiff3 | tkdiff | xxdiff | meld | opendiff | emerge | vimdiff | gvimdiff | ecmerge)
138 ;; # happy
140 if ! valid_custom_tool "$1"
141 then
142 return 1
145 esac
148 # Sets up the merge_tool_path variable.
149 # This handles the mergetool.<tool>.path configuration.
150 init_merge_tool_path() {
151 merge_tool_path=$(git config mergetool."$1".path)
152 if test -z "$merge_tool_path"; then
153 case "$1" in
154 emerge)
155 merge_tool_path=emacs
158 merge_tool_path="$1"
160 esac
164 # Allow the GIT_MERGE_TOOL variable to provide a default value
165 test -n "$GIT_MERGE_TOOL" && merge_tool="$GIT_MERGE_TOOL"
167 # If not merge tool was specified then use the merge.tool
168 # configuration variable. If that's invalid then reset merge_tool.
169 if test -z "$merge_tool"; then
170 merge_tool=$(git config merge.tool)
171 if test -n "$merge_tool" && ! valid_tool "$merge_tool"; then
172 echo >&2 "git config option merge.tool set to unknown tool: $merge_tool"
173 echo >&2 "Resetting to default..."
174 unset merge_tool
178 # Try to guess an appropriate merge tool if no tool has been set.
179 if test -z "$merge_tool"; then
181 # We have a $DISPLAY so try some common UNIX merge tools
182 if test -n "$DISPLAY"; then
183 merge_tool_candidates="kdiff3 tkdiff xxdiff meld gvimdiff"
184 # If gnome then prefer meld
185 if test -n "$GNOME_DESKTOP_SESSION_ID"; then
186 merge_tool_candidates="meld $merge_tool_candidates"
188 # If KDE then prefer kdiff3
189 if test "$KDE_FULL_SESSION" = "true"; then
190 merge_tool_candidates="kdiff3 $merge_tool_candidates"
194 # $EDITOR is emacs so add emerge as a candidate
195 if echo "${VISUAL:-$EDITOR}" | grep 'emacs' > /dev/null 2>&1; then
196 merge_tool_candidates="$merge_tool_candidates emerge"
199 # $EDITOR is vim so add vimdiff as a candidate
200 if echo "${VISUAL:-$EDITOR}" | grep 'vim' > /dev/null 2>&1; then
201 merge_tool_candidates="$merge_tool_candidates vimdiff"
204 merge_tool_candidates="$merge_tool_candidates opendiff emerge vimdiff"
205 echo "merge tool candidates: $merge_tool_candidates"
207 # Loop over each candidate and stop when a valid merge tool is found.
208 for i in $merge_tool_candidates
210 init_merge_tool_path $i
211 if type "$merge_tool_path" > /dev/null 2>&1; then
212 merge_tool=$i
213 break
215 done
217 if test -z "$merge_tool" ; then
218 echo "No known merge resolution program available."
219 exit 1
222 else
223 # A merge tool has been set, so verify that it's valid.
224 if ! valid_tool "$merge_tool"; then
225 echo >&2 "Unknown merge tool $merge_tool"
226 exit 1
229 init_merge_tool_path "$merge_tool"
231 if test -z "$merge_tool_cmd" && ! type "$merge_tool_path" > /dev/null 2>&1; then
232 echo "The merge tool $merge_tool is not available as '$merge_tool_path'"
233 exit 1
238 # Launch the merge tool on each path provided by 'git diff'
239 while test $# -gt 6
241 launch_merge_tool "$1" "$2" "$5"
242 shift 7
243 done